SystemOrganization addCategory: #'SIMS-Person'!
SystemOrganization addCategory: #'SIMS-Core'!
SystemOrganization addCategory: #'SIMS-Furniture'!
SystemOrganization addCategory: #'SIMS-Garments'!
SystemOrganization addCategory: #'SIMS-Prepositions'!
SystemOrganization addCategory: #'SIMS-Roles'!

Object subclass: #SimBody
	instanceVariableNames: 'age layout condition eyeColor gender hairColor handedness height person skinColor weight'
	classVariableNames: 'BodyParts BodyTemplates EyeColors HairColors SkinColors'
	poolDictionaries: ''
	category: 'SIMS-Person'!

!SimBody commentStamp: '<historical>' prior: 0!
Bodies describe all the physical attributes of a Person.!

!SimBody class methodsFor: 'instance creation' stamp: 'btr 4/18/2002 17:21'!
for: aPerson gender: aGender
	^ self new person: aPerson; gender: aGender! !

!SimBody class methodsFor: 'class initialization' stamp: 'btr 4/18/2002 18:22'!
initialize
	"Body parts ending in 's' are pairs, left and right. If singulars or  
	plurals connect to plurals, they do so one by one."
	"SimBody initialize"
	| humanForm |
	BodyParts _ Dictionary newFrom: {#eyes -> #face. #ears -> #head. #nose -> #face. #tongue -> #mouth. #mouth -> #face. #face -> #head. #head -> #neck. #neck -> #shoulders. #shoulders -> #chest. #breasts -> #chest. #chest -> #trunk. #belly -> #abdomen. #abdomen -> #trunk. #trunk -> #spine. #thighs -> #waist. #knees -> #thighs. #calves -> #knees. #ankles -> #calves. #feet -> #ankles. #upperarms -> #shoulders. #elbows -> #upperarms. #lowerarms -> #elbows. #wrists -> #lowerarms. #hands -> #wrists. #tail -> #tailbone. #tailbone -> #spine. #waist -> #spine}.
	humanForm _ BodyParts copy.
	humanForm removeKey: #tail.
	BodyTemplates _ Dictionary newFrom: {#human -> humanForm. #man
					-> (humanForm copy add: #maleGenitalia -> #waist). #woman -> (humanForm copy add: #breasts -> #abdomen;
						 add: #femaleGenitalia -> #waist). #dog -> BodyParts. #cat -> BodyParts}.
	"Note: albino is separate."
	EyeColors _ Set newFrom: #(#blue #brown #green #grey #hazel #black ).
	HairColors _ Set newFrom: #(#blonde #brown #auburn #grey #black #red ).
	SkinColors _ Set newFrom: #(#pale #white #olive #brown #yellow #black )! !

!SimBody methodsFor: 'accessing' stamp: 'btr 4/16/2002 18:59'!
age
	^ age! !

!SimBody methodsFor: 'accessing' stamp: 'btr 4/16/2002 18:59'!
age: newValue
	age _ newValue.! !

!SimBody methodsFor: 'accessing' stamp: 'btr 4/22/2002 23:10'!
defaultHand
	^ (handedness ifNil: [#right]) , #Hand! !

!SimBody methodsFor: 'accessing' stamp: 'btr 4/16/2002 19:01'!
eyeColor
	^ eyeColor! !

!SimBody methodsFor: 'accessing' stamp: 'btr 4/16/2002 19:01'!
eyeColor: newValue
	eyeColor _ newValue.! !

!SimBody methodsFor: 'accessing' stamp: 'btr 4/15/2002 01:10'!
gender
	^ gender! !

!SimBody methodsFor: 'accessing' stamp: 'btr 11/16/2002 14:31'!
gender: aGender 
	"This only gets called knowing adulthood, so dispatch can be done."
	gender
		ifNotNil: [self notYetImplemented].
	aGender isMale
		ifTrue: [layout _ BodyTemplates at: #man].
	aGender isFemale
		ifTrue: [layout _ BodyTemplates at: #woman]
		ifFalse: [layout _ BodyTemplates at: #human].
	gender _ aGender! !

!SimBody methodsFor: 'accessing' stamp: 'btr 4/16/2002 19:01'!
hairColor
	^ hairColor! !

!SimBody methodsFor: 'accessing' stamp: 'btr 4/16/2002 19:01'!
hairColor: newValue
	hairColor _ newValue.! !

!SimBody methodsFor: 'accessing' stamp: 'btr 4/22/2002 23:06'!
handedness
	^ handedness! !

!SimBody methodsFor: 'accessing' stamp: 'btr 4/22/2002 23:06'!
handedness: newValue
	^ handedness ifNil: [handedness _ newValue]
		ifNotNil: [self error: handedness , 'is already initialized.'].! !

!SimBody methodsFor: 'accessing' stamp: 'btr 4/16/2002 18:59'!
height
	^ height! !

!SimBody methodsFor: 'accessing' stamp: 'btr 4/16/2002 18:59'!
height: newValue
	height _ newValue.! !

!SimBody methodsFor: 'accessing' stamp: 'btr 4/18/2002 21:19'!
layout
	^ layout! !

!SimBody methodsFor: 'accessing' stamp: 'btr 4/18/2002 21:19'!
layout: aDictionary
	layout _ aDictionary.! !

!SimBody methodsFor: 'accessing' stamp: 'btr 4/15/2002 01:13'!
person
	^ person! !

!SimBody methodsFor: 'accessing' stamp: 'btr 4/15/2002 01:14'!
person: aPerson
	person ifNotNil: [self error: 'Body re-assignment doesn''t work.'].
	person _ aPerson! !

!SimBody methodsFor: 'accessing' stamp: 'btr 4/16/2002 19:00'!
weight
	^ weight! !

!SimBody methodsFor: 'accessing' stamp: 'btr 4/16/2002 19:00'!
weight: newValue
	weight _ newValue.! !

Object subclass: #SimBodyState
	instanceVariableNames: 'bladder carrying cleanliness clothing energy hunger injuries intoxication person'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Person'!

!SimBodyState commentStamp: '<historical>' prior: 0!
BodyStates are temporal (stricly) physical conditions of any kind.!

!SimBodyState methodsFor: 'accessing' stamp: 'btr 4/18/2002 18:43'!
bladder
	^ bladder! !

!SimBodyState methodsFor: 'accessing' stamp: 'btr 4/18/2002 18:43'!
bladder: newValue
	bladder _ newValue.! !

!SimBodyState methodsFor: 'accessing' stamp: 'btr 4/22/2002 22:58'!
carrying
	^ carrying! !

!SimBodyState methodsFor: 'accessing' stamp: 'btr 4/22/2002 22:58'!
carrying: aIdentityDictionary 
	carrying ifNil: [carrying _ aIdentityDictionary]! !

!SimBodyState methodsFor: 'accessing' stamp: 'btr 4/18/2002 18:50'!
cleanliness
	^ cleanliness! !

!SimBodyState methodsFor: 'accessing' stamp: 'btr 4/18/2002 18:50'!
cleanliness: aNumber
	cleanliness _ aNumber.! !

!SimBodyState methodsFor: 'accessing' stamp: 'btr 4/18/2002 18:49'!
clothing
	^ clothing! !

!SimBodyState methodsFor: 'accessing' stamp: 'btr 4/20/2002 12:55'!
clothing: aDictionary 
	"A mapping from BodyParts to Garments."
	clothing _ aDictionary! !

!SimBodyState methodsFor: 'accessing' stamp: 'btr 4/18/2002 18:49'!
energy
	^ energy! !

!SimBodyState methodsFor: 'accessing' stamp: 'btr 4/18/2002 18:49'!
energy: aNumber
	energy _ aNumber.! !

!SimBodyState methodsFor: 'accessing' stamp: 'btr 4/18/2002 18:48'!
hunger
	^ hunger! !

!SimBodyState methodsFor: 'accessing' stamp: 'btr 4/18/2002 18:48'!
hunger: aNumber
	hunger _ aNumber.! !

!SimBodyState methodsFor: 'initialize-release' stamp: 'btr 4/22/2002 22:59'!
initialize
	self carrying: IdentityDictionary new.! !

!SimBodyState methodsFor: 'accessing' stamp: 'btr 4/18/2002 18:48'!
injuries
	^ injuries! !

!SimBodyState methodsFor: 'accessing' stamp: 'btr 4/18/2002 18:48'!
injuries: aDictionary
	injuries _ aDictionary.! !

!SimBodyState methodsFor: 'accessing' stamp: 'btr 4/18/2002 18:49'!
intoxication
	^ intoxication! !

!SimBodyState methodsFor: 'accessing' stamp: 'btr 4/18/2002 18:49'!
intoxication: aNumber
	intoxication _ aNumber.! !

!SimBodyState methodsFor: 'accessing' stamp: 'btr 4/18/2002 18:44'!
person
	^ person! !

!SimBodyState methodsFor: 'accessing' stamp: 'btr 4/18/2002 18:44'!
person: newValue
	^ person ifNil: [person _ newValue]
		ifNotNil: [self error: person , 'is already initialized.'].! !

Object subclass: #SimConversationist
	instanceVariableNames: 'conversation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Roles'!

!SimConversationist methodsFor: 'accessing' stamp: 'btr 4/23/2002 00:38'!
conversation
	^ conversation! !

!SimConversationist methodsFor: 'accessing' stamp: 'btr 4/23/2002 00:38'!
conversation: aConversation
	conversation _ aConversation.! !

Object subclass: #SimGender
	instanceVariableNames: ''
	classVariableNames: 'Female Male'
	poolDictionaries: ''
	category: 'SIMS-Person'!

!SimGender commentStamp: '<historical>' prior: 0!
Genders are aspects of Bodies that affect overall personality and Role capabilities, and are extensible, though with two obvious constants. Age may later become a factor as well.

TODO: Evaluate whether or how species should count.!

!SimGender class methodsFor: 'accessing' stamp: 'btr 4/13/2002 23:57'!
female
	^ Female! !

!SimGender class methodsFor: 'class initialization' stamp: 'btr 4/13/2002 23:59'!
initialize
	Male
		ifNil: [Male _ self new]
		ifNotNil: [Male becomeForward: self new].
	Female
		ifNil: [Female _ self new]
		ifNotNil: [Female becomeForward: self new]! !

!SimGender class methodsFor: 'accessing' stamp: 'btr 4/15/2002 00:21'!
instancesForName: aString
	"Answer genders satisfying aString as a name.
	TODO: find a personal name parser and adapt it."
	^ Set with: self male with: self female! !

!SimGender class methodsFor: 'accessing' stamp: 'btr 4/13/2002 23:57'!
male
	^ Male! !

!SimGender methodsFor: 'testing' stamp: 'btr 4/15/2002 00:58'!
isFemale
	^ self == self class female! !

!SimGender methodsFor: 'testing' stamp: 'btr 4/15/2002 00:57'!
isMale
	^ self == self class male! !

!SimGender methodsFor: 'testing' stamp: 'btr 4/18/2002 21:38'!
isOther
	^ self isMale not and: [self isFemale not]! !

Object subclass: #SimMind
	instanceVariableNames: 'person rolesPriority'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Person'!

!SimMind commentStamp: '<historical>' prior: 0!
A Mind is the focus for the decisions about a Person's actions, both in invoking and evaluating them. This top class is very abstract.!

!SimMind methodsFor: 'accessing' stamp: 'btr 4/22/2002 22:41'!
condition
	^ person condition! !

!SimMind methodsFor: 'initialize-release' stamp: 'btr 4/22/2002 22:49'!
initialize
	rolesPriority _ IdentityDictionary new.! !

!SimMind methodsFor: 'accessing' stamp: 'btr 4/22/2002 22:36'!
person
	^ person! !

!SimMind methodsFor: 'accessing' stamp: 'btr 4/22/2002 22:51'!
person: aPerson 
	person _ aPerson.
	person condition roles do: [:each | rolesPriority at: each put: nil]! !

!SimMind methodsFor: 'actions' stamp: 'btr 4/23/2002 00:47'!
prioritize: aRole
	"Everything starts out at a default level."
	^ 255! !

!SimMind methodsFor: 'accessing' stamp: 'btr 4/22/2002 22:48'!
rolesPriority
	^ rolesPriority! !

!SimMind methodsFor: 'accessing' stamp: 'btr 4/22/2002 22:49'!
rolesPriority: anIdentityDictionary 
	rolesPriority ifNil: [rolesPriority _ anIdentityDictionary]! !

Object subclass: #SimObject
	instanceVariableNames: 'location'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Core'!

!SimObject commentStamp: '<historical>' prior: 0!
Objects are the most generic kind of concrete thing in the Simulation.!

SimObject subclass: #SimFurniture
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Furniture'!

SimObject subclass: #SimGarment
	instanceVariableNames: 'material colors'
	classVariableNames: 'DefaultBodyPart'
	poolDictionaries: ''
	category: 'SIMS-Garments'!

SimGarment subclass: #SimBathingSuit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Garments'!

!SimBathingSuit class methodsFor: 'class initialization' stamp: 'btr 4/18/2002 20:33'!
initialize
	DefaultBodyPart _ #waist! !

SimGarment subclass: #SimBra
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Garments'!

!SimBra class methodsFor: 'class initialization' stamp: 'btr 4/18/2002 20:38'!
initialize
	DefaultBodyPart _ #waist! !

SimGarment subclass: #SimBracelet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Garments'!

!SimBracelet class methodsFor: 'class initialization' stamp: 'btr 4/18/2002 20:40'!
initialize
	DefaultBodyPart _ #wrist! !

!SimGarment methodsFor: 'accessing' stamp: 'btr 4/18/2002 20:51'!
colors
	^ colors! !

!SimGarment methodsFor: 'accessing' stamp: 'btr 4/18/2002 20:51'!
colors: aSet
	colors _ aSet.! !

!SimGarment methodsFor: 'accessing' stamp: 'btr 4/18/2002 20:44'!
defaultBodyPart
	^ DefaultBodyPart! !

!SimGarment methodsFor: 'accessing' stamp: 'btr 4/18/2002 20:52'!
material
	^ material! !

!SimGarment methodsFor: 'accessing' stamp: 'btr 4/18/2002 20:52'!
material: aMaterial
	material _ aMaterial.! !

SimGarment subclass: #SimGlasses
	instanceVariableNames: 'power tint'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Garments'!

!SimGlasses class methodsFor: 'class initialization' stamp: 'btr 4/18/2002 20:40'!
initialize
	DefaultBodyPart _ #eyes! !

SimGarment subclass: #SimHat
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Garments'!

!SimHat class methodsFor: 'class initialization' stamp: 'btr 4/18/2002 20:40'!
initialize
	DefaultBodyPart _ #head! !

SimGarment subclass: #SimNecklace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Garments'!

!SimNecklace class methodsFor: 'class initialization' stamp: 'btr 4/18/2002 20:40'!
initialize
	DefaultBodyPart _ #neck! !

SimGarment subclass: #SimPants
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Garments'!

!SimPants class methodsFor: 'class initialization' stamp: 'btr 4/18/2002 20:40'!
initialize
	DefaultBodyPart _ #legs! !

SimGarment subclass: #SimRing
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Garments'!

!SimRing class methodsFor: 'class initialization' stamp: 'btr 4/18/2002 20:41'!
initialize
	DefaultBodyPart _ #finger! !

SimGarment subclass: #SimShirt
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Garments'!

!SimShirt class methodsFor: 'class initialization' stamp: 'btr 4/18/2002 20:42'!
initialize
	DefaultBodyPart _ #trunk! !

SimGarment subclass: #SimShoes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Garments'!

!SimShoes class methodsFor: 'class initialization' stamp: 'btr 4/18/2002 20:42'!
initialize
	DefaultBodyPart _ #feet! !

SimGarment subclass: #SimShorts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Garments'!

SimGarment subclass: #SimSkirt
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Garments'!

!SimSkirt class methodsFor: 'class initialization' stamp: 'btr 4/19/2002 20:06'!
initialize
	DefaultBodyPart _ #waist! !

SimGarment subclass: #SimSocks
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Garments'!

!SimSocks class methodsFor: 'class initialization' stamp: 'btr 4/18/2002 20:42'!
initialize
	DefaultBodyPart _ #feet! !

SimGarment subclass: #SimUnderwear
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Garments'!

!SimUnderwear class methodsFor: 'class initialization' stamp: 'btr 4/18/2002 20:42'!
initialize
	DefaultBodyPart _ #waist! !

SimGarment subclass: #SimWristWatch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Garments'!

!SimWristWatch class methodsFor: 'class initialization' stamp: 'btr 4/18/2002 20:42'!
initialize
	DefaultBodyPart _ #wrist! !

!SimObject class methodsFor: 'accessing instances and variables' stamp: 'btr 4/17/2002 19:02'!
belongingTo: aPerson
	"Answer the(?) object of my type that the Person has.
	Subclasses should override this to provide appropriate meanings."
	| inv items |
	inv _ aPerson condition inventory.
	items _ inv select: [:each | each class == self].
	items isEmpty ifTrue: [^ nil].
	1 = items size ifTrue: [^ items anyOne].
	^ items! !

!SimObject methodsFor: 'testing' stamp: 'btr 4/20/2002 14:13'!
canFit: aPlace 
	"TODO: Implement this once a coordinate system with region-structuring 
	is implemented."
	^ true! !

!SimObject methodsFor: 'testing' stamp: 'btr 4/20/2002 14:34'!
isPartOf: aPlace 
	"This is a highly generic recursive method. It even works on Persons."
	^ aPlace == self
		or: [location
				ifNil: [false]
				ifNotNil: [location isPartOf: aPlace]]! !

!SimObject methodsFor: 'accessing' stamp: 'btr 4/14/2002 01:36'!
location
	^ location! !

!SimObject methodsFor: 'accessing' stamp: 'btr 2/29/2004 21:35'!
location: aPlace 
	"Move myself to the specific Place."
	(self canFit: aPlace)
		ifFalse: [self error: 'This can''t fit there.'].
	location subPlaces remove: self.
	aPlace subPlaces add: self.
	location _ aPlace! !

SimObject subclass: #SimPile
	instanceVariableNames: 'items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Person'!

!SimPile commentStamp: '<historical>' prior: 0!
A Pile is a stack of Objects.!

!SimPile class methodsFor: 'instance creation' stamp: 'btr 4/17/2002 19:09'!
fromCollection: aCollection
	^ self new items: (OrderedCollection newFrom: aCollection)! !

!SimPile methodsFor: 'accessing' stamp: 'btr 2/29/2004 21:32'!
itemType
	"The most generic type encompassing all Pile items."
	| classes |
	classes _ (items collect: [:each | each class]) asSet.
	[classes size > 1]
		whileTrue: [classes _ classes
			collect: [:each | classes
				detect: [:class | each inheritsFrom: class]
				ifNone: [nil]]].
	^ classes anyOne! !

!SimPile methodsFor: 'accessing' stamp: 'btr 4/17/2002 19:10'!
items
	^ items ifNil: [OrderedCollection new]! !

!SimPile methodsFor: 'accessing' stamp: 'btr 2/29/2004 21:28'!
items: aCollection 
	aCollection
		do: [:obj | obj location: self]! !

!SimPile methodsFor: 'actions' stamp: 'btr 4/17/2002 19:17'!
pop
	"Take an object off the pile and put it into the surrounding space for safety."
	| item |
	item _ items removeLast.
	item location: self location.
	^ item! !

!SimPile methodsFor: 'actions' stamp: 'btr 4/17/2002 19:16'!
push: anObject 
	"Put anObject on top of the Pile."
	anObject location: self! !

!SimPile methodsFor: 'actions' stamp: 'btr 4/18/2002 13:07'!
scatter
	"Take all the Objects from the Pile, put them in the surrounding area, and remove the Pile."
	| dest |
	dest _ self location.
	items do: [:obj | obj location: dest].
	items _ OrderedCollection new.
	dest subPlaces remove: self.
	location _ nil! !

!SimPile methodsFor: 'accessing' stamp: 'btr 4/17/2002 19:13'!
subPlaces
	"Here for false polymorphism with SimPlace to support  
	SimObject>>location:."
	^ self items! !

SimObject subclass: #SimPlace
	instanceVariableNames: 'vicinity name subPlaces'
	classVariableNames: 'WorldLobby'
	poolDictionaries: ''
	category: 'SIMS-Core'!

!SimPlace commentStamp: '<historical>' prior: 0!
Places hold Objects and other Places. Places also link to other Places "horizontally". Note that sub-Places are to be used sparingly, for very specific formal relationships, because using it too loosely messes up the logic.!

SimPlace subclass: #SimDescribedPlace
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Core'!

!SimDescribedPlace methodsFor: 'accessing' stamp: 'btr 2/29/2004 21:19'!
description
	^ description! !

!SimDescribedPlace methodsFor: 'accessing' stamp: 'btr 2/29/2004 21:19'!
description: aText
	description _ aText! !

SimDescribedPlace subclass: #SimResidence
	instanceVariableNames: 'residents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Core'!

!SimResidence commentStamp: '<historical>' prior: 0!
Residences are Places with people living there.!

!SimResidence class methodsFor: 'accessing instances and variables' stamp: 'btr 4/18/2002 13:46'!
of: aPerson
	^ aPerson residence! !

!SimResidence methodsFor: 'accessing' stamp: 'btr 4/15/2002 00:27'!
residents
	^ residents! !

!SimResidence methodsFor: 'accessing' stamp: 'btr 4/15/2002 00:27'!
residents: aSet
	residents _ aSet! !

SimPlace subclass: #SimGridPlace
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Core'!

!SimGridPlace commentStamp: 'btr 3/1/2004 00:08' prior: 0!
A Place whose subPlaces are arranged on a two-dimensional grid, with Integer coordinates.
This will not immediately allocate all places in the grid; that should be performed lazily.!

!SimGridPlace class methodsFor: 'instance creation' stamp: 'btr 3/1/2004 00:06'!
width: x height: y 
	^ self new subPlaces: (Array2D width: x height: y)! !

!SimGridPlace methodsFor: 'enumerating' stamp: 'btr 3/1/2004 00:07'!
subPlacesDo: aBlock
	subPlaces do: [:each | each ifNotNil: [aBlock value: each]]! !

!SimGridPlace methodsFor: 'private' stamp: 'btr 3/1/2004 00:16'!
vicinityClass
	^ SimGridVicinity! !

!SimPlace class methodsFor: 'class initialization' stamp: 'btr 4/14/2002 00:45'!
initialize
	WorldLobby ifNil: [WorldLobby _ self new]
		ifNotNil: [WorldLobby becomeForward: self new]! !

!SimPlace class methodsFor: 'accessing' stamp: 'btr 4/14/2002 00:45'!
lobby
	^ WorldLobby! !

!SimPlace class methodsFor: 'instance creation' stamp: 'btr 4/14/2002 01:40'!
new
	^ super new adjacentPlaces: Bag new;
				subPlaces: Set new! !

!SimPlace class methodsFor: 'instance creation' stamp: 'btr 3/1/2004 00:10'!
newInTheVicinityOf: aCollection 
	| newPlace |
	newPlace _ super new adjacentPlaces: aCollection.
	aCollection
		do: [:eachPlace | eachPlace adjacentPlaces add: newPlace].
	^ newPlace! !

!SimPlace class methodsFor: 'instance creation' stamp: 'btr 11/16/2002 15:17'!
newNextTo: aPlace 
	| newPlace |
	newPlace _ super new
				adjacentPlaces: (OrderedCollection with: aPlace);
				 location: aPlace location.
	aPlace adjacentPlaces add: newPlace.
	^ newPlace! !

!SimPlace class methodsFor: 'instance creation' stamp: 'btr 3/1/2004 00:15'!
newWithin: parentPlace
	^ super new vicinity: parentPlace vicinityClass new! !

!SimPlace methodsFor: 'accessing' stamp: 'btr 2/29/2004 22:32'!
adjacentPlaces
	^ vicinity neighborsOf: self! !

!SimPlace methodsFor: 'accessing' stamp: 'GDK 10/13/2019 13:40'!
adjacentPlaces: aCollection
	vicinity ifNotNil: [vicinity setNeighborsOf: self to: aCollection]! !

!SimPlace methodsFor: 'accessing' stamp: 'btr 2/29/2004 23:13'!
description
	^ ''! !

!SimPlace methodsFor: 'querying' stamp: 'btr 11/16/2002 15:28'!
findPathFrom: source to: target
	"Find a reasonable path between the two subPlaces. This is especially important to override for Places with particular geometries, such as Grids. It's intended that all normal path searches go through this interface. This returns an OrderedCollection of the Places in the path, not including the source."
	| here visitedPlaces path block |
	path _ OrderedCollection new: (subPlaces // 2).
	visitedPlaces _ Set new: subPlaces size.
	here _ source.
	block _ [:each |
		(visitedPlaces includes: each)
			ifTrue: [here last == each ifTrue: [path remove: here]]
			ifFalse: [path addLast: each. visitedPlaces noCheckAdd: each.
		each == target ifTrue: [^ path].
		]].
	here neighborsDo: block.
	! !

!SimPlace methodsFor: 'testing' stamp: 'btr 2/29/2004 23:25'!
isAdjacentTo: aPlace 
	^ vicinity is: self adjacentTo: aPlace! !

!SimPlace methodsFor: 'accessing' stamp: 'btr 4/13/2002 23:50'!
name
	^ name! !

!SimPlace methodsFor: 'accessing' stamp: 'btr 4/13/2002 23:50'!
name: aString
	name _ aString! !

!SimPlace methodsFor: 'enumerating' stamp: 'btr 2/29/2004 23:30'!
neighborsDo: aBlock 
	self adjacentPlaces do: aBlock! !

!SimPlace methodsFor: 'accessing' stamp: 'btr 4/14/2002 01:38'!
subPlaces
	^ subPlaces! !

!SimPlace methodsFor: 'accessing' stamp: 'btr 4/14/2002 01:38'!
subPlaces: aCollection
	subPlaces _ aCollection! !

!SimPlace methodsFor: 'private' stamp: 'btr 3/1/2004 00:12'!
vicinity: aVicinity
	vicinity _ aVicinity! !

!SimPlace methodsFor: 'private' stamp: 'btr 3/1/2004 00:15'!
vicinityClass
	^ SimVicinity! !

!SimPlace methodsFor: 'enumerating' stamp: 'btr 4/15/2002 15:13'!
whatsHere
	"Iterate through the levels of sub-places, picking up things that are not 
	places. "
	| stuffHere recursionBlock |
	stuffHere _ Set new.
	recursionBlock _ [:stuffSet :nextPlace | (nextPlace isKindOf: SimPlace)
				ifTrue: [nextPlace subPlaces inject: stuffSet into: recursionBlock]
				ifFalse: [stuffSet add: nextPlace]].
	subPlaces inject: stuffHere into: recursionBlock.
	^ stuffHere! !

!SimPlace methodsFor: 'enumerating' stamp: 'btr 4/15/2002 15:13'!
whatsNearby
	| stuffNearby |
	stuffNearby _ self whatsHere.
	self neighborsDo: [:each | stuffNearby addAll: (each whatsHere)].
	^ stuffNearby! !

SimPlace subclass: #SimPreposition
	instanceVariableNames: 'places preposition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Prepositions'!

!SimPreposition commentStamp: '<historical>' prior: 0!
Preposition places are those which have specific relationships to SimObjects.

e.g. inside, on, above, between...!

SimPreposition subclass: #SimPluralPreposition
	instanceVariableNames: 'objects'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Prepositions'!

SimPluralPreposition subclass: #SimAmong
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Prepositions'!

!SimAmong methodsFor: 'accessing' stamp: 'btr 4/19/2002 22:23'!
objects: aCollection 
	aCollection size >= 2
		ifFalse: [self error: 'You can''t be among less than 2 objects.'].
	objects
		ifNil: [objects _ aCollection]! !

SimPluralPreposition subclass: #SimBetween
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Prepositions'!

!SimBetween methodsFor: 'accessing' stamp: 'btr 4/19/2002 21:02'!
objects: aCollection 
	aCollection size >= 2
		ifFalse: [self error: 'You can''t be between less than 2 objects.'].
	objects ifNil: [objects _ aCollection]! !

!SimPluralPreposition class methodsFor: 'instance creation' stamp: 'btr 4/19/2002 21:12'!
for: aCollection
	^ self new objects: aCollection! !

!SimPluralPreposition methodsFor: 'accessing' stamp: 'btr 4/19/2002 21:12'!
objects
	^ objects! !

!SimPluralPreposition methodsFor: 'accessing' stamp: 'btr 4/19/2002 21:12'!
objects: aCollection 
	aCollection size >= 2
		ifFalse: [self error: 'You can''t be between less than 2 objects.'].
	objects ifNil: [objects _ aCollection]! !

!SimPreposition class methodsFor: 'instance creation' stamp: 'btr 4/19/2002 21:08'!
for: anObject
	self subclassResponsibility! !

SimPreposition subclass: #SimUnaryPreposition
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Prepositions'!

SimUnaryPreposition subclass: #SimAbove
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Prepositions'!

SimUnaryPreposition subclass: #SimBehind
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Prepositions'!

SimUnaryPreposition subclass: #SimInFrontOf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Prepositions'!

SimUnaryPreposition subclass: #SimOnTopOf
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Prepositions'!

!SimUnaryPreposition class methodsFor: 'instance creation' stamp: 'btr 4/19/2002 22:04'!
for: anObject
	^ self new object: anObject! !

!SimUnaryPreposition methodsFor: 'accessing' stamp: 'btr 4/19/2002 22:04'!
object
	^ object! !

!SimUnaryPreposition methodsFor: 'accessing' stamp: 'btr 4/19/2002 22:04'!
object: aObject 
	object ifNil: [object _ aObject]! !

SimUnaryPreposition subclass: #SimUnder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Prepositions'!

Object subclass: #SimPerson
	instanceVariableNames: 'body condition job mind name residence so'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Person'!

!SimPerson commentStamp: '<historical>' prior: 0!
Persons are the core elements of the Simulation. They have various attributes which should not be shared, such as Bodies and Names.!

!SimPerson class methodsFor: 'instance creation' stamp: 'btr 4/18/2002 17:29'!
name: aName gender: aGender age: aNumber 
	^ self new name: aName;
		 age: aNumber
		 gender: aGender! !

!SimPerson class methodsFor: 'instance creation' stamp: 'btr 4/16/2002 14:41'!
named: aName
	| newPerson possibleGenders |
	newPerson _ self new name: aName.
	possibleGenders _ SimGender instancesForName: aName first.
	possibleGenders size = 1
		ifTrue: [newPerson gender: possibleGenders anyOne].
	newPerson
		condition: (SimPersonState for: newPerson).
	^ newPerson! !

!SimPerson methodsFor: 'roles' stamp: 'btr 4/23/2002 00:46'!
addRole: aRole
	self
		addRole: aRole
		priority: (mind prioritize: aRole)! !

!SimPerson methodsFor: 'roles' stamp: 'btr 4/23/2002 00:41'!
addRole: aRole priority: aNumber
	condition roles add: aRole.
	mind rolesPriority at: aRole put: aNumber! !

!SimPerson methodsFor: 'accessing' stamp: 'btr 4/15/2002 01:08'!
age
	^ body age! !

!SimPerson methodsFor: 'accessing' stamp: 'btr 4/15/2002 01:08'!
age: aNumber 
	body age: aNumber! !

!SimPerson methodsFor: 'accessing' stamp: 'btr 4/18/2002 17:33'!
age: anAge gender: aGender 
	anAge >= 13
		ifTrue: [self body: SimBody human.
			body gender: aGender]
		ifFalse: [self
				body: (SimBody for: self gender: aGender)].
	body age: anAge! !

!SimPerson methodsFor: 'accessing' stamp: 'btr 4/18/2002 15:01'!
body
	^ body! !

!SimPerson methodsFor: 'accessing' stamp: 'btr 4/18/2002 15:01'!
body: newValue
	^ body ifNil: [body _ newValue]
		ifNotNil: [self error: body , 'is already initialized.'].! !

!SimPerson methodsFor: 'testing' stamp: 'btr 4/20/2002 14:10'!
canFit: aPlace
	"TODO: Implement this once a coordinate system with region-structuring is implemented."
	^ true! !

!SimPerson methodsFor: 'testing' stamp: 'btr 4/15/2002 01:25'!
canReach: aPlace
	"TODO: make this more generic"
	aPlace == condition location! !

!SimPerson methodsFor: 'accessing' stamp: 'btr 4/14/2002 00:32'!
condition
	^ condition! !

!SimPerson methodsFor: 'accessing' stamp: 'btr 4/15/2002 00:14'!
condition: aPersonState
	condition _ aPersonState! !

!SimPerson methodsFor: 'conversations' stamp: 'btr 4/15/2002 00:51'!
createConversationWith: aPerson
	^ SimConversation between: self and: aPerson! !

!SimPerson methodsFor: 'conversations' stamp: 'btr 4/15/2002 00:53'!
createConversationWithAll: aSet
	^ SimConversation among: (aSet add: self)! !

!SimPerson methodsFor: 'actions' stamp: 'btr 4/15/2002 00:47'!
drop: anObject 
	(self has: anObject)
		ifFalse: [self error: self name , 'doesn''t have that.'].
	condition inventory remove: anObject.
	anObject location: condition location! !

!SimPerson methodsFor: 'conversations' stamp: 'btr 2/29/2004 20:36'!
enterConversation: aConversation 
	aConversation includeParticipant: self! !

!SimPerson methodsFor: 'accessing' stamp: 'btr 4/15/2002 01:09'!
gender
	^ body gender! !

!SimPerson methodsFor: 'actions' stamp: 'btr 4/14/2002 00:51'!
getOutOfHere
	"Go to some random place if you can."
	| places |
	places _ condition location adjacentPlaces.
	places isEmpty
		ifTrue: [self error: 'There''s nowhere I can go!!'].
	self go: places atRandom! !

!SimPerson methodsFor: 'actions' stamp: 'btr 4/23/2002 00:34'!
give: anObject to: aPerson 
	(aPerson wants: anObject)
		ifFalse: [self error: aPerson name , 'doesn''t want that.'].
	(self has: anObject)
		ifFalse: [self error: self name , 'doesn''t have that to give.'].
	aPerson condition inventory add: anObject.
	condition inventory remove: anObject.
	aPerson grab: anObject.
	self releaseGripFrom: anObject! !

!SimPerson methodsFor: 'actions' stamp: 'btr 4/20/2002 14:11'!
go: aPlace 
	^ (condition place adjacentPlaces includes: aPlace)
		ifTrue: [self condition location: aPlace]
		ifFalse: [self error: aPlace name , ' isn''t next to here.']! !

!SimPerson methodsFor: 'actions' stamp: 'btr 4/23/2002 00:10'!
grab: anObject 
	"Grab with the default hand. If that's not available, use the other 
	hand. "
	| carrying hand |
	carrying _ body condition carrying.
	hand _ body defaultHand.
	(carrying at: hand)
		ifNil: [carrying at: hand put: anObject]
		ifNotNil: [(hand at: 1)
					== $r
				ifTrue: [self leftGrab: anObject]
				ifFalse: [self rightGrab: anObject]]! !

!SimPerson methodsFor: 'testing' stamp: 'btr 4/15/2002 00:41'!
has: anObject
	^ condition inventory includes: anObject! !

!SimPerson methodsFor: 'conversations' stamp: 'btr 11/16/2002 00:04'!
hear: aText
	"TODO: add a hook for a simple parser, or allow for the Text to be some structured object-statement or recursive array encoding."! !

!SimPerson methodsFor: 'conversations' stamp: 'btr 11/16/2002 13:33'!
hear: aText from: aPerson in: aConversation 
	"React to something that is said within a context. Ordinarily this ignores 
	the context and just updates information or some random entertainment."

	^self hear: aText! !

!SimPerson methodsFor: 'accessing' stamp: 'btr 11/16/2002 13:53'!
here
	^ condition location! !

!SimPerson methodsFor: 'testing' stamp: 'btr 4/14/2002 00:54'!
isEmployed
	^ job notNil! !

!SimPerson methodsFor: 'testing' stamp: 'btr 11/16/2002 14:32'!
isFemale
	^ body gender isFemale! !

!SimPerson methodsFor: 'testing' stamp: 'btr 4/14/2002 00:01'!
isHomeless
	^ residence isNil! !

!SimPerson methodsFor: 'testing' stamp: 'btr 4/14/2002 00:33'!
isJobless
	^ job isNil! !

!SimPerson methodsFor: 'testing' stamp: 'btr 11/16/2002 14:32'!
isMale
	^ body gender isMale! !

!SimPerson methodsFor: 'testing' stamp: 'btr 4/20/2002 14:33'!
isPartOf: aPlace 
	"This is a highly generic recursive method. It is compatible with the same method on Objects and Places."
	^ aPlace == self
		or: [condition location
				ifNil: [false]
				ifNotNil: [condition location isPartOf: aPlace]]! !

!SimPerson methodsFor: 'testing' stamp: 'btr 4/14/2002 00:55'!
isUnemployed
	^ job isNil! !

!SimPerson methodsFor: 'accessing' stamp: 'btr 4/13/2002 23:38'!
job
	^ job! !

!SimPerson methodsFor: 'accessing' stamp: 'btr 4/13/2002 23:47'!
job: aJob
	job _ aJob! !

!SimPerson methodsFor: 'actions-group' stamp: 'btr 11/15/2002 23:52'!
join: aGroup
	(aGroup acceptsParticipant: self)
		ifTrue: [aGroup includeParticipant: self]
		ifFalse: [self notifyRejectedBy: aGroup]! !

!SimPerson methodsFor: 'conversations' stamp: 'btr 2/29/2004 20:37'!
leaveConversation: aConversation 
	aConversation removeParticipant: self! !

!SimPerson methodsFor: 'actions' stamp: 'btr 4/22/2002 23:03'!
leftGrab: anObject
	| carrying |
	carrying _ body condition carrying.
	carrying at: anObject put: #leftHand! !

!SimPerson methodsFor: 'accessing' stamp: 'btr 4/22/2002 22:33'!
mind
	^ mind! !

!SimPerson methodsFor: 'accessing' stamp: 'btr 4/22/2002 22:33'!
mind: aMind
	mind _ aMind.! !

!SimPerson methodsFor: 'accessing' stamp: 'btr 4/13/2002 23:46'!
name
	^ name! !

!SimPerson methodsFor: 'accessing' stamp: 'btr 4/16/2002 14:40'!
name: aPersonName
	name _ aPersonName! !

!SimPerson methodsFor: 'actions-group' stamp: 'btr 11/15/2002 22:42'!
notifyDisbanded: aGroup
	"Do nothing for now."! !

!SimPerson methodsFor: 'actions-group' stamp: 'btr 11/15/2002 23:52'!
notifyRejectedBy: aGroup
	"Do nothing by default."! !

!SimPerson methodsFor: 'actions-group' stamp: 'btr 2/29/2004 20:37'!
partFrom: aGroup 
	aGroup notifyIsLeaving: self.
	aGroup removeParticipant: self! !

!SimPerson methodsFor: 'actions' stamp: 'btr 4/15/2002 01:33'!
pickUp: anObject 
	(self canReach: anObject location)
		ifFalse: [self error: 'That''s not reachable from here.'].
	anObject location: self.
	condition inventory add: anObject! !

!SimPerson methodsFor: 'actions' stamp: 'btr 4/20/2002 14:24'!
place: anObject in: aPlace 
	| inv |
	inv _ condition inventory.
	(inv includes: anObject)
		ifFalse: [self error: self name , 'doesn''t have that.'].
	(self canReach: aPlace)
		ifFalse: [self error: self name , 'can''t reach there.'].
	(anObject canFit: aPlace)
		ifFalse: [self error: 'That won''t fit there.'].
	inv remove: anObject.
	anObject location: aPlace! !

!SimPerson methodsFor: 'actions' stamp: 'btr 4/23/2002 00:24'!
releaseGripFrom: anObject 
	"Fail quietly, so that this can be invoked conservatively."
	body condition carrying
		removeKey: anObject
		ifAbsent: []! !

!SimPerson methodsFor: 'roles' stamp: 'btr 4/23/2002 00:43'!
removeCompletedRole: aRole
	aRole isComplete
		ifFalse: [self error: 'That role is still active.'].
	condition roles remove: aRole.
	mind rolesPriority
		remove: aRole
		ifAbsent: []! !

!SimPerson methodsFor: 'accessing' stamp: 'btr 4/13/2002 23:38'!
residence
	^ residence! !

!SimPerson methodsFor: 'accessing' stamp: 'btr 4/15/2002 00:26'!
residence: aPlace 
	(aPlace isKindOf: SimResidence)
		ifFalse: [self error: self name , 'cannot live there.'].
	aPlace residents add: self.
	residence _ aPlace! !

!SimPerson methodsFor: 'actions' stamp: 'btr 4/22/2002 23:03'!
rightGrab: anObject 
	| carrying |
	carrying _ body condition carrying.
	carrying at: anObject put: #rightHand! !

!SimPerson methodsFor: 'conversations' stamp: 'btr 11/16/2002 13:33'!
say: aText in: aConversation 
	"Distribute the message and let the listeners react to it in the context."

	aConversation participants 
		hear: aText
		from: aConversation
		in: self! !

!SimPerson methodsFor: 'actions' stamp: 'btr 4/18/2002 19:21'!
shed: aGarment from: aBodyPart 
	"Takes a Garment off a person, using stacks over BodyParts. Places the garment in the inventory. The Garment has to be topmost."
	| clothing |
	clothing _ body condition clothing
		at: aBodyPart
		ifAbsent: [self error: 'That body part has no clothing.'].
	"TODO: add the check for topmost-ness."
	clothing
		remove: aGarment
		ifAbsent: [self error: 'That body part isn''t wearing that.'].
	condition inventory
		add: aGarment! !

!SimPerson methodsFor: 'actions' stamp: 'btr 4/23/2002 00:34'!
take: anObject from: aPerson 
	(self wants: anObject)
		ifFalse: [self error: self name , 'doesn''t want that.'].
	(aPerson has: anObject)
		ifFalse: [self error: aPerson name , 'doesn''t have that to give.'].
	condition inventory add: anObject.
	aPerson condition inventory remove: anObject.
	aPerson releaseGripFrom: anObject.
	self grab: anObject! !

!SimPerson methodsFor: 'testing' stamp: 'btr 4/15/2002 00:37'!
wants: anObject
	"For now, all are greedy little pack-rats."
	^ anObject isKindOf: SimObject! !

!SimPerson methodsFor: 'actions' stamp: 'btr 4/18/2002 18:37'!
wear: aGarment on: aBodyPart 
	"Puts a Garment on a person, using stacks over BodyParts"
	| clothing |
	condition inventory
		remove: aGarment
		ifAbsent: [self error: self name , 'isn''t holding that.'].
	clothing _ body condition clothing.
	clothing
		at: aBodyPart
		put: ((clothing
				at: aBodyPart
				ifAbsent: [OrderedCollection new])
				addLast: aGarment)! !

Object subclass: #SimPersonName
	instanceVariableNames: 'first middle surname titles'
	classVariableNames: 'FamilyNames FemaleNames MaleNames Titles'
	poolDictionaries: ''
	category: 'SIMS-Person'!

!SimPersonName commentStamp: '<historical>' prior: 0!
Person names are structured names and titles.!

!SimPersonName class methodsFor: 'instance creation' stamp: 'btr 4/16/2002 09:32'!
first: firstString middle: middleString last: lastString titles: anArrayOrNil
	^ self new first: firstString;
		middle: middleString;
		last: lastString;
		titles: anArrayOrNil! !

!SimPersonName class methodsFor: 'class initialization' stamp: 'btr 4/18/2002 18:04'!
initialize
	"Load up the name databases if not present or in an image segment  
	already."
	MaleNames
		ifNil: [].
	FemaleNames
		ifNil: [].
	FamilyNames
		ifNil: [].
	Titles
		ifNil: [Titles _ Set withAll: #('Mr.' 'Mrs.' 'Ms.' 'Dr.' 'Miss' )]! !

!SimPersonName class methodsFor: 'instance creation' stamp: 'btr 4/16/2002 10:53'!
newAtRandom
	| gender family |
	gender _ SimGender allInstances atRandom.
	family _ FamilyNames atRandom.
	gender isMale
		ifTrue: [^ self newMaleFromFamily: family].
	gender isFemale
		ifTrue: [^ self newFemaleFromFamily: family]! !

!SimPersonName class methodsFor: 'instance creation' stamp: 'btr 4/16/2002 10:45'!
newFemaleFromFamily: aSurname 
	"TODO: introduce checking for same first and middle names, and for 
	name clashes among family members."
	^ self
		first: FemaleNames atRandom
		middle: FemaleNames atRandom
		last: aSurname
		titles: #()! !

!SimPersonName class methodsFor: 'instance creation' stamp: 'btr 4/16/2002 10:45'!
newMaleFromFamily: aSurname
	"TODO: introduce checking for same first and middle names, and for name clashes among family members."
	^ self first: MaleNames atRandom
		middle: MaleNames atRandom
		last: aSurname
		titles: #()! !

!SimPersonName class methodsFor: 'class initialization' stamp: 'btr 4/16/2002 14:23'!
openNameDatabase: aFilename
	"Takes a filename relative to the hardwired path and loads up the file, returning the contents as a collection, each line into element as a String."
	| file result |
	file _ (FileStream oldFileNamed: SimWorld gameDirectory , aFilename) text.
	result _ Set new.
	[file atEnd] whileFalse: [result add: (file upTo: file cr)].
	file close.
	^ result! !

!SimPersonName methodsFor: 'accessing' stamp: 'btr 4/16/2002 09:25'!
first
	^ first! !

!SimPersonName methodsFor: 'accessing' stamp: 'btr 4/16/2002 09:25'!
first: newValue
	first _ newValue.! !

!SimPersonName methodsFor: 'accessing' stamp: 'btr 4/16/2002 09:25'!
middle
	^ middle! !

!SimPersonName methodsFor: 'accessing' stamp: 'btr 4/16/2002 09:25'!
middle: newValue
	middle _ newValue.! !

!SimPersonName methodsFor: 'accessing' stamp: 'btr 4/16/2002 09:25'!
surname
	^ surname! !

!SimPersonName methodsFor: 'accessing' stamp: 'btr 4/16/2002 09:25'!
surname: newValue
	surname _ newValue.! !

!SimPersonName methodsFor: 'accessing' stamp: 'btr 4/16/2002 09:25'!
titles
	^ titles! !

!SimPersonName methodsFor: 'accessing' stamp: 'btr 4/16/2002 09:25'!
titles: newValue
	titles _ newValue.! !

Object subclass: #SimPersonState
	instanceVariableNames: 'environment happiness inventory location person roles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Person'!

!SimPersonState commentStamp: '<historical>' prior: 0!
Person-states describe the non-physical temporal attributes of a Person that are not specifically physical.!

!SimPersonState class methodsFor: 'instance creation' stamp: 'btr 4/15/2002 00:11'!
for: aPerson
	"Set up and initialize a state for the person argument."
	aPerson condition ifNotNil: [self notYetImplemented].
	^ self new person: aPerson! !

!SimPersonState class methodsFor: 'instance creation' stamp: 'btr 4/15/2002 00:33'!
new
	^ super new inventory: Set new;
		roles: Set new! !

!SimPersonState methodsFor: 'accessing' stamp: 'btr 4/17/2002 18:39'!
environment
	^ environment ifNil: [environment _ Dictionary new]! !

!SimPersonState methodsFor: 'accessing' stamp: 'btr 4/17/2002 18:39'!
environment: newValue
	environment _ newValue.! !

!SimPersonState methodsFor: 'accessing' stamp: 'btr 4/15/2002 00:06'!
inventory
	^ inventory! !

!SimPersonState methodsFor: 'accessing' stamp: 'btr 4/15/2002 00:07'!
inventory: aCollection
	inventory _ aCollection! !

!SimPersonState methodsFor: 'accessing' stamp: 'btr 4/14/2002 00:56'!
location
	^ location! !

!SimPersonState methodsFor: 'accessing' stamp: 'btr 4/20/2002 14:12'!
location: aPlace 
	(person canFit: aPlace)
		ifFalse: [self error: person name , 'can''t fit there.'].
	location _ aPlace! !

!SimPersonState methodsFor: 'accessing' stamp: 'btr 4/14/2002 00:56'!
person
	^ person! !

!SimPersonState methodsFor: 'accessing' stamp: 'btr 4/15/2002 00:09'!
person: aPerson 
	person
		ifNotNil: [self error: 'Personal states cannot be re-assigned.'].
	person _ aPerson! !

!SimPersonState methodsFor: 'accessing' stamp: 'btr 4/15/2002 00:29'!
roles
	^ roles! !

!SimPersonState methodsFor: 'accessing' stamp: 'btr 4/15/2002 00:29'!
roles: aSet
	roles _ aSet! !

Object subclass: #SimRole
	instanceVariableNames: 'complete permanence subRoles timeBegan'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Roles'!

!SimRole commentStamp: '<historical>' prior: 0!
Roles are things that Persons enter into which have definite scope and extent.!

SimRole subclass: #SimCombat
	instanceVariableNames: 'attacker defender'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Roles'!

!SimCombat commentStamp: 'btr 11/15/2002 22:46' prior: 0!
Combat is defined asymmetrically, with an attacker and defender. The attacker merely takes action first and gains advantage. The parties may be aware of each other ahead of time.!

!SimCombat methodsFor: 'accessing' stamp: 'btr 11/15/2002 23:37'!
attacker
	^attacker! !

!SimCombat methodsFor: 'accessing' stamp: 'btr 11/15/2002 23:37'!
attacker: anObject
	attacker := anObject! !

!SimCombat methodsFor: 'accessing' stamp: 'btr 11/15/2002 23:37'!
defender
	^defender! !

!SimCombat methodsFor: 'accessing' stamp: 'btr 11/15/2002 23:37'!
defender: anObject
	defender := anObject! !

SimRole subclass: #SimGroup
	instanceVariableNames: 'participants'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Roles'!

!SimGroup commentStamp: 'btr 11/16/2002 13:36' prior: 0!
Groups are generic sets of Persons. This is mostly an abstract class.!

SimGroup subclass: #SimConversation
	instanceVariableNames: 'subject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Roles'!

!SimConversation commentStamp: '<historical>' prior: 0!
Conversations are events between sets of Persons which have some kind of (potentially volatile) topic, and affect Friendships.!

!SimConversation class methodsFor: 'instance creation' stamp: 'btr 11/15/2002 23:44'!
among: aSet 
	^ super new
		participants: (WeakSet withAll: aSet);
		 subject: 'Greetings'! !

!SimConversation class methodsFor: 'instance creation' stamp: 'btr 11/15/2002 23:44'!
between: aPerson and: anotherPerson 
	^ super new
		participants: (WeakSet with: aPerson with: anotherPerson);
		 subject: 'Greetings'! !

!SimConversation class methodsFor: 'instance creation' stamp: 'btr 11/15/2002 23:45'!
new
	^ super new participants: WeakSet new;
		 subject: 'Greetings'! !

!SimConversation methodsFor: 'accessing' stamp: 'btr 4/14/2002 00:07'!
subject
	^ subject! !

!SimConversation methodsFor: 'accessing' stamp: 'btr 4/14/2002 00:11'!
subject: aString
	subject _ aString! !

SimGroup subclass: #SimFriendship
	instanceVariableNames: 'strength'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Roles'!

!SimFriendship commentStamp: '<historical>' prior: 0!
Friendships are Roles among sets of Persons which have a strength scalar, and have no other intrinsic basis. It is intended for Conversations to build friendships, although Gifts and Activities are planned as well.!

!SimFriendship methodsFor: 'accessing' stamp: 'btr 4/15/2002 01:39'!
participants
	^ participants! !

!SimFriendship methodsFor: 'accessing' stamp: 'btr 4/15/2002 01:40'!
participants: aSet
	participants _ aSet! !

!SimFriendship methodsFor: 'accessing' stamp: 'btr 4/15/2002 01:39'!
strength
	^ strength! !

!SimFriendship methodsFor: 'accessing' stamp: 'btr 4/15/2002 01:40'!
strength: aNumber
	strength _ aNumber! !

!SimGroup class methodsFor: 'instance creation' stamp: 'btr 11/16/2002 13:23'!
new: size
	^ self new initialize participants: (WeakSet new: size)! !

!SimGroup class methodsFor: 'instance creation' stamp: 'btr 11/16/2002 13:24'!
newFrom: aCollection 
	^ self new initialize participants: (WeakSet newFrom: aCollection)! !

!SimGroup methodsFor: 'testing' stamp: 'btr 11/15/2002 22:36'!
acceptsParticipant: aPerson 
	"Generic Groups don't have any restrictions."
	^ true! !

!SimGroup methodsFor: 'actions' stamp: 'btr 11/15/2002 22:39'!
disband
	participants do: [:each | each notifyDisbanded: self].
	participants _ participants class new! !

!SimGroup methodsFor: 'actions' stamp: 'btr 2/29/2004 20:36'!
includeParticipant: aPerson 
	"Generic groups just accept anyone. They have no meaning. Override  
	this to perform a semantic check for the group type."
	participants add: aPerson! !

!SimGroup methodsFor: 'testing' stamp: 'btr 11/16/2002 13:56'!
isDispersed
	"Answer whether all the participants are in the same Place."
	| place |
	place _ participants anyOne here.
	participants
		do: [:each | each here ~= place
				ifTrue: [^ false]].
	^ true! !

!SimGroup methodsFor: 'testing' stamp: 'btr 11/16/2002 14:00'!
isScattered
	"Answer whether all the participants are nearby some Place. This is done randomly, since the alternative involves intersecting the nearby places of all of them."
	| place |
	place _ participants anyOne here.
	participants
		do: [:each | (each here isAdjacentTo: place)
				ifTrue: [^ false]].
	^ true! !

!SimGroup methodsFor: 'actions' stamp: 'btr 11/16/2002 13:21'!
notifyIsLeaving: aPerson
	"Tell the participants that the Person is parting from the Group."
	participants do: [:each | each inform: aPerson name , ' has left ' , self name]! !

!SimGroup methodsFor: 'accessing' stamp: 'btr 11/15/2002 22:43'!
participants
	^ participants! !

!SimGroup methodsFor: 'accessing' stamp: 'btr 11/15/2002 22:43'!
participants: aSet
	participants _ aSet! !

!SimGroup methodsFor: 'actions' stamp: 'btr 2/29/2004 20:37'!
removeParticipant: aPerson 
	"Generic groups just accept anyone. They have no meaning. Override  
	this to perform a semantic check for the group type."
	participants remove: aPerson! !

SimGroup subclass: #SimTeam
	instanceVariableNames: 'leader goalTest goalScore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Roles'!

!SimTeam commentStamp: 'btr 11/15/2002 23:23' prior: 0!
Teams are Groups that have some measurable goal, or at least some interest that can be advanced.!

!SimTeam methodsFor: 'accessing' stamp: 'btr 11/15/2002 23:24'!
goalScore
	^ goalScore value! !

!SimTeam methodsFor: 'accessing' stamp: 'btr 11/15/2002 23:24'!
goalScoreBlock
	^ goalScore! !

!SimTeam methodsFor: 'accessing' stamp: 'btr 11/15/2002 23:25'!
goalScoreBlock: aBlock
	goalScore _ aBlock! !

!SimTeam methodsFor: 'accessing' stamp: 'btr 11/15/2002 22:27'!
goalTest
	^ goalTest! !

!SimTeam methodsFor: 'accessing' stamp: 'btr 11/15/2002 22:28'!
goalTest: testBlock
	goalTest _ testBlock! !

!SimTeam methodsFor: 'testing' stamp: 'btr 11/15/2002 22:44'!
hasSucceeded
	^ goalTest value! !

!SimTeam methodsFor: 'testing' stamp: 'btr 11/16/2002 13:58'!
isScattered
	"Overridden to specify that the participants have to be near to the leader, if there is one."
	| place |
	leader ifNil: [^ super isScattered]
		ifNotNil: [place _ leader here.
		participants do: [:each | each here ~= place
			ifTrue: [^ false]].
		^ true]! !

!SimRole class methodsFor: 'instance creation' stamp: 'btr 4/21/2002 14:57'!
new
	^ super new initialize! !

!SimRole methodsFor: 'initialize-release' stamp: 'btr 4/21/2002 14:58'!
initialize
	subRoles _ Set new.
	complete _ false! !

!SimRole methodsFor: 'testing' stamp: 'btr 4/21/2002 14:52'!
isComplete
	^ complete! !

!SimRole methodsFor: 'actions' stamp: 'btr 4/21/2002 14:56'!
markComplete
	complete _ true! !

!SimRole methodsFor: 'accessing' stamp: 'btr 4/21/2002 14:13'!
permanence
	^ permanence! !

!SimRole methodsFor: 'accessing' stamp: 'btr 4/21/2002 14:13'!
permanence: aTimeSpan
	permanence _ aTimeSpan.! !

!SimRole methodsFor: 'accessing' stamp: 'btr 4/21/2002 14:50'!
subRoles
	^ subRoles! !

!SimRole methodsFor: 'accessing' stamp: 'btr 4/21/2002 14:58'!
subRoles: aSet 
	subRoles _ aSet! !

!SimRole methodsFor: 'accessing' stamp: 'btr 4/21/2002 14:12'!
timeBegan
	^ timeBegan! !

!SimRole methodsFor: 'accessing' stamp: 'btr 4/21/2002 14:12'!
timeBegan: newValue
	^ timeBegan ifNil: [timeBegan _ newValue]
		ifNotNil: [self error: timeBegan , 'is already initialized.'].! !

SimRole subclass: #SimStaying
	instanceVariableNames: 'places'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Roles'!

!SimStaying commentStamp: '<historical>' prior: 0!
A Staying is a self-imposed restriction of some Persons' location to a set of Places, usually for a reason. TODO: encode the reason dependence!

!SimStaying methodsFor: 'accessing' stamp: 'btr 4/21/2002 14:13'!
places
	^ places! !

!SimStaying methodsFor: 'accessing' stamp: 'btr 4/21/2002 14:13'!
places: aSet
	places _ aSet.! !

SimRole subclass: #SimTask
	instanceVariableNames: 'completionTest'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Roles'!

!SimTask commentStamp: '<historical>' prior: 0!
Tasks are Roles with specific completion conditions.!

!SimTask class methodsFor: 'instance creation' stamp: 'btr 11/15/2002 22:24'!
satisfying: aBlock 
	^ self new completionTest: aBlock! !

!SimTask methodsFor: 'accessing' stamp: 'btr 4/21/2002 15:08'!
completionSpec: aBlock
	completionSpec _ aBlock.! !

!SimTask methodsFor: 'accessing' stamp: 'btr 11/15/2002 22:24'!
completionTest
	^ completionTest! !

!SimTask methodsFor: 'accessing' stamp: 'btr 11/15/2002 22:24'!
completionTest: aBlock 
	completionTest _ aBlock! !

!SimTask methodsFor: 'testing' stamp: 'btr 4/21/2002 15:14'!
isComplete
	self markComplete.
	^ complete! !

!SimTask methodsFor: 'actions' stamp: 'btr 11/16/2002 14:33'!
markComplete
	"All sub-Roles must be complete, and the completionTest must be  
	satisfied."
	"TODO: raise an exception on failure?"
	completionTest value
		ifFalse: [^ self].
	subRoles
		do: [:each | each isComplete not
				ifTrue: [^ self]].
	super markComplete! !

Object subclass: #SimVicinity
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Core'!

!SimVicinity commentStamp: 'btr 2/29/2004 23:38' prior: 0!
Vicinity abstraction for objects, ie "what's next to here". Vicinities are used in a manner that allows them to be object-specific or shared among a whole set. The abstract default treats all siblings (subPlaces of the object's location) as neighbors.!

SimVicinity subclass: #SimGatewayGroup
	instanceVariableNames: 'namesToPlaces'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Core'!

!SimGatewayGroup commentStamp: 'btr 2/29/2004 23:46' prior: 0!
Records in a Dictionary of Dictionaries the set of gateways between objects. So the first key is the origin, and the keys in the dictionary stored there are gates.!

!SimGatewayGroup methodsFor: 'accessing' stamp: 'btr 2/29/2004 23:51'!
addGateFrom: origin to: destination named: name
	(namesToPlaces at: origin ifAbsentPut: Dictionary new)
		at: name put: destination! !

!SimGatewayGroup methodsFor: 'accessing' stamp: 'btr 2/29/2004 23:44'!
neighborsOf: anObject 
	^ (namesToPlaces at: anObject) values! !

!SimGatewayGroup methodsFor: 'accessing' stamp: 'btr 2/29/2004 23:57'!
removeGateFrom: origin named: name 
	| dict |
	dict _ namesToPlaces at: origin ifAbsent: [^ nil].
	dict at: name ifPresent: [dict removeKey: name]! !

!SimGatewayGroup methodsFor: 'accessing' stamp: 'btr 2/29/2004 23:56'!
removeGateFrom: origin to: destination named: name 
	| dict |
	dict _ namesToPlaces at: origin ifAbsent: [^ nil].
	dict at: name ifPresent: [:value | value == destination ifTrue: [dict removeKey: name]]! !

!SimGatewayGroup methodsFor: 'accessing' stamp: 'btr 2/29/2004 22:40'!
setNeighborsOf: anObject to: aCollection
	"TODO: Fill in generic keys?"
	self error: 'Gateways must be named.'! !

SimVicinity subclass: #SimGridVicinity
	instanceVariableNames: 'grid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Core'!

!SimGridVicinity commentStamp: 'btr 2/29/2004 22:30' prior: 0!
Handles the vicinities of all grid elements.!

!SimGridVicinity methodsFor: 'accessing' stamp: 'btr 2/29/2004 22:59'!
grid
	^ grid! !

!SimGridVicinity methodsFor: 'accessing' stamp: 'btr 2/29/2004 22:59'!
grid: aGridPlace
	grid _ aGridPlace! !

!SimGridVicinity methodsFor: 'testing' stamp: 'btr 2/29/2004 23:41'!
is: aPlace adjacentTo: potentialNeighbor 
	^ (super is: aPlace adjacentTo: potentialNeighbor)
		and: [(self neighborsOf: aPlace) includes: potentialNeighbor]! !

!SimGridVicinity methodsFor: 'accessing' stamp: 'btr 2/29/2004 22:49'!
neighborsOf: aGridPlace
	| x y neighbors |
	x _ aGridPlace x.
	y _ aGridPlace y.
	neighbors _ Set new: 8.
	x < grid width
		ifTrue: [y < grid height ifTrue: [neighbors add: (grid at: x + 1 at: y + 1)].
				y > 0 ifTrue: [neighbors add: (grid at: x + 1 at: y - 1)].
				neighbors add: (grid at: x + 1 at: y)].
	x > 0
		ifTrue: [y < grid height ifTrue: [neighbors add: (grid at: x - 1 at: y + 1)].
				y > 0 ifTrue: [neighbors add: (grid at: x - 1 at: y - 1)].
				neighbors add: (grid at: x - 1 at: y)].
	y < grid height ifTrue: [neighbors add: (grid at: x at: y + 1)].
	y > 0 ifTrue: [neighbors add: (grid at: x at: y - 1)].
	^ neighbors! !

!SimGridVicinity methodsFor: 'accessing' stamp: 'btr 2/29/2004 22:55'!
setNeighborsOf: aPlace to: somePlaces
	"TODO: implement this as an extension mechanism?"
	self error: 'The object is in a grid vicinity.'! !

!SimGridVicinity methodsFor: 'private' stamp: 'btr 3/1/2004 00:16'!
vicinityClass
	^ SimGridVicinity! !

!SimVicinity methodsFor: 'testing' stamp: 'btr 2/29/2004 23:30'!
is: aPlace adjacentTo: potentialNeighbor 
	^ aPlace location == potentialNeighbor location! !

!SimVicinity methodsFor: 'accessing' stamp: 'btr 2/29/2004 23:35'!
neighborsOf: aPlace 
	^ aPlace location subPlaces copyWithout: aPlace! !

!SimVicinity methodsFor: 'accessing' stamp: 'btr 2/29/2004 22:37'!
setNeighborsOf: aPlace to: aCollection
	self subclassResponsibility! !

Object subclass: #SimWorld
	instanceVariableNames: 'characters places currentTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SIMS-Core'!

!SimWorld commentStamp: '<historical>' prior: 0!
Worlds encompass all the material associated with one Simulation, including clock-time.!

!SimWorld class methodsFor: 'accessing' stamp: 'btr 4/16/2002 10:20'!
gameDirectory
	"Hard-wired right now."
	^ '/Users/water/Documents/SqSims/'! !

!SimWorld class methodsFor: 'instance creation' stamp: 'btr 4/14/2002 23:28'!
new
	^ super new places: Set new;
		characters: Set new! !

!SimWorld methodsFor: 'accessing' stamp: 'btr 4/14/2002 23:25'!
characters
	^ characters! !

!SimWorld methodsFor: 'accessing' stamp: 'btr 4/14/2002 23:27'!
characters: aSet
	characters _ aSet! !

!SimWorld methodsFor: 'accessing' stamp: 'btr 4/14/2002 23:25'!
places
	^ places! !

!SimWorld methodsFor: 'accessing' stamp: 'btr 4/14/2002 23:27'!
places: aSet
	places _ aSet! !

!SimWorld methodsFor: 'accessing' stamp: 'btr 4/14/2002 23:26'!
time
	^ currentTime! !
SimBody initialize!
SimGender initialize!
SimBathingSuit initialize!
SimBra initialize!
SimBracelet initialize!
SimGlasses initialize!
SimHat initialize!
SimNecklace initialize!
SimPants initialize!
SimRing initialize!
SimShirt initialize!
SimShoes initialize!
SimSkirt initialize!
SimSocks initialize!
SimUnderwear initialize!
SimWristWatch initialize!
SimPlace initialize!
SimPersonName initialize!
